
#include <htc.h>

__CONFIG(FOSC_INTRCIO & WDTE_OFF & PWRTE_OFF & MCLRE_OFF & CP_OFF & CPD_OFF);



#define Incr_Btn    GPIObits.GPIO1
#define Decr_Btn    GPIObits.GPIO0
#define OnOff_Btn   GPIObits.GPIO5 //if 1st pressed, incr and decr btn start work for incementing ind decrementing thr brightmess
#define DIMMER_1    GPIObits.GPIO4      //GPIObits.GPIO4

#define ZERO_CROSS  GPIObits.GPIO2      // ZC INT decleared

///////////////ISR PROTOTYPE/////////////
void timer1Isr();


/////////ARRAY VARIABLE DEFINITION and VALUE ASSIGN//////////////////
unsigned int dimmerspeed[1]={0};       
unsigned int dimmerdelay[1]={0};
//unsigned char num=0, delay=0;

#define DIMMER_MAX 5

/////////////////initial ISR///////////////////
void interrupt tintr(void)
{  
   if(INTCONbits.INTF)               //Check RB0 PIN INTERRUPT FOR ZC FLAG
   {
     //INT pin has detected falling 
     TMR1H = 0xF7;
     TMR1L = 0xFF;  
     T1CONbits.TMR1ON=1; //timer1 on
     dimmerdelay[0]=(DIMMER_MAX-dimmerspeed[0])<<1;   //dimmerspeed has already updated in main()
     timer1Isr();
     OPTION_REGbits.INTEDG ^= 1;

      INTCONbits.INTF   =0;
   }
      
   else if(PIR1bits.TMR1IF)               // check the timer1 over flow interrupt flag 
   {
   timer1Isr();                              //FLAG SET 2.048 mSec
   PIR1bits.TMR1IF =0;
   }
   
}



void main() 
{
   //unsigned char change_dimmer = 0;
    CMCON=0x7;              // disable the comparator 
    ANSEL=0x00;             // all pin are Digital
    TRISIO=0x2F;            // GP4> triac OUTPUT, all others input
  
   
   //clear TMR1
   TMR1H = 0;
   TMR1L = 0;
   //
   OPTION_REG = 0x80; //FALLING EDGE INT, pullups are disabled   
   //                         
  
   // INT/GP2/ZC
   INTCONbits.INTE = 1;      // INT PIN ZC 
   INTCONbits.INTF = 0;      // INT PIN ZC
   //Timer1 Load:
   /*FOSC=4mhz, timer1 input is (4/4=1mhz)
    * ps=1,
    *tick=1uSec,
    * 2mSec delay=2000 tick,
    * load TMR1=65536-2000=63536=0xF830
    */
   T1CON = 0x00; //PRESCALER 1:1, Timer1 OFF
   PIE1bits.TMR1IE = 1;
   PIR1bits.TMR1IF = 0;
   //Global
   INTCONbits.PEIE = 1;     // peripheral intrrupt enable
   INTCONbits.GIE = 1;      // GLOBL interrupt enable
   

   
   while(1)                 // wait forever for  the data received and ready  
   {
       //delay=2;
       dimmerspeed[0]=2;
       
   
   }//while
   
}//main


//////////////////timer1 ISR//////////////////////////

void timer1Isr()    // every  2.048 ms         
{
   if(dimmerdelay[0])
   {
      DIMMER_1=1;
      if(!(dimmerdelay[0]&0x8000))
         dimmerdelay[0]--;
   }else
   {
      DIMMER_1=0;
      dimmerdelay[0]=0xFFFF;
           
   }

}
 